#!/bin/sh
#
# this script will be lanched by Makefile to install the boot
# script

BOOTPROG=devolo
BOOTDIR=/etc/init.d

if [[ "$1" = "uninstall" ]]; then
    proceduretype="uninstall";
    if [ -e $BOOTDIR/$BOOTPROG ]; then
    echo
    echo "Found boot script $BOOTPROG installed."
    echo "Starting boot-uninstalling procedure..."
    else
        echo "Boot script $BOOTPROG not installed."
 	exit
    fi
else
    echo Starting boot-installing procedure...
    proceduretype="install";
fi


rc3dir=`find /etc -type d -name rc3.d 2>/dev/null`
RCPATH=${rc3dir%%rc3.d}

RUNLEVELS="2 3 5"
STARPREF="S99"
KILLPREF="K80"
WELCOME="/etc/issue"
SUPPORTED="RedHat Debian SuSE Ubuntu"

if [[ $UID -ne 0 ]]; then
    echo
    echo "You must be root to (un)install the boot script"
    exit
fi

if [ -f $WELCOME ]; then
    for DISTRIBUTION in $SUPPORTED; do
	found=`test "$DISTRIBUTION" = "RedHat" && grep -i red $WELCOME|grep -i hat || grep -i $DISTRIBUTION $WELCOME`
	if [ -n "$found" ];then
	    break
	fi
    done
fi

test -z "$found" && DISTRIBUTION=""

echo  $DISTRIBUTION $RCPATH

#checkdistribution:
if [[ "$proceduretype" = "uninstall" ]]; then

    echo 
#    echo " WARNING: The uninstall procedure is potentially dangerous."
    if test -z "$DISTRIBUTION" ; then 
	echo 
	echo " WARNING: This procedure has been properly tested "
	echo "on RedHat, Suse, Debian and Ubuntu, please read the INSTALL"
	echo "file before going on."
    fi
    echo "The boot script $BOOTPROG will be removed from"
    echo "$BOOTDIR and links to it will be cancelled from"
    echo "the subdirectories (rc3.d and rc5.d) of $RCPATH"
    echo "If you want to go on, please enter 'Y'. "
    read answ
    if [ "$answ" != "y" -a "$answ" != "Y" ]; then
	exit
    fi    
else
    if test -z "$DISTRIBUTION" ; then 
	echo 
	echo " WARNING: this procedure has been properly tested "
	echo "on RedHat, Suse, Debian and Ubuntu, please read the INSTALL"
	echo "file before going on. The boot script $BOOTPROG"
	echo "will be installed in $BOOTDIR and links to it will be"
	echo "created in the subdirectories (rc3.d and rc5.d) of $RCPATH"
	echo "If you want to go on, please enter 'Y'. "
	read answ
	if [ "$answ" != "y" -a "$answ" != "Y" ]; then
	    exit
	fi
    fi
fi

if test ! -d $BOOTDIR; then 
    echo "directory $BOOTDIR does not exist!"
    echo "please enter a different directory or exit with 'q'"

    read BOOTDIR
    if [ ! -d $BOOTDIR -o "$BOOTDIR" = "q" ]; then
	echo "exiting.."
	exit
    fi
fi

if [[ "$proceduretype" = "uninstall" ]]; then    
    echo "uninstalling $BOOTPROG in $BOOTDIR...." 
    rm -f $BOOTDIR/$BOOTPROG

    if  test -n $RCPATH; then 
	cd $RCPATH && 
	for i in $RUNLEVELS; do 
	    test -d rc$i.d && cd rc$i.d 
	    rm -f $STARPREF$BOOTPROG
	    rm -f $KILLPREF$BOOTPROG	    
	    cd ..
	done 	
    fi   
else
    echo "installing $BOOTPROG in $BOOTDIR...." 
    install -m 744  $BOOTPROG $BOOTDIR
    
    if  test -n $RCPATH; then 
	cd $RCPATH && 
	for i in $RUNLEVELS; do 
	    test -d rc$i.d && cd rc$i.d 
	    rm -f *$BOOTPROG
	    echo creating link to $BOOTPROG in $PWD 
	    ln -s $BOOTDIR/$BOOTPROG $STARPREF$BOOTPROG 
	    ln -s $BOOTDIR/$BOOTPROG $KILLPREF$BOOTPROG 
	    cd ..
	done 
	
    fi
fi 

