/* 
   pl_son.c: DLANConfig tool for HomePlug devices foo linux

   Written 2003 by devolo AG

*/

#include "dlanconfig.h"

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <pcap.h>
#include <netinet/in.h> 
#include <signal.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/uio.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <netinet/if_ether.h>
#include <sys/mman.h> 
#include <linux/if_packet.h> 

#include <signal.h>

void MyCallback( char *Args, const struct pcap_pkthdr* hdr, unsigned char *packet);

/*
 *   This exec is loaded from dlanconfig with a vfork 
 */

pcap_t* pcapDescr;             
void sig_handler (int sig)
{
	if(pcapDescr)
	pcap_close(pcapDescr);
}

int main( int argc,char** argv)
{
  
	char errbuf[PCAP_ERRBUF_SIZE]; 
	char iname[MAX_INAME_LEN]="";
	
	if(argc<2) {
	exit(EXIT_FAILURE);
	}
	
	if(getuid()!=0){
	printf("\nYou must be root to run dlanconfig tool.\n"); 
	printf("Bye bye\n"); 
	return 0;
	}
	
	signal(15,sig_handler);
	signal(16,sig_handler);
	
	strncpy(iname,argv[1],MAX_INAME_LEN);
	fflush(stdout);
	pcapDescr = pcap_open_live(iname,BUFSIZ,0,100,errbuf);
	if(pcapDescr == NULL) {
	
	fprintf(stderr,"[ERROR]: pl_son: pcapLoop error errbuf=%s\n",errbuf);
	//    exit(EXIT_FAILURE);
	return EXIT_FAILURE;
	}
	
	pcap_loop(pcapDescr,-1, (void*)MyCallback, (unsigned char*)iname);
	_exit(0);
}


/*
 *   Callback for pcap_loop function
 */
void MyCallback( char *Args, const struct pcap_pkthdr* hdr, unsigned char *packet)
{
	struct MME_PackedHdr* ph;
	char lenStr[16]="";
	if(packet == NULL)
	return;
	
	ph=(struct MME_PackedHdr*)packet;
	
	if ( (ph->Ethertype == htons(ETHERTYPE_INTELLON)) || (ph->Ethertype == htons(ETHERTYPE_AV200) ))
	{
		sprintf(lenStr, "%-4d", hdr->len);
		write(STDOUT_FILENO, lenStr, 4);
		write(STDOUT_FILENO, packet, hdr->len);
	}
  
}




