/*
 *   This code is based on MD5 message-digest algorithm originally written
 *   by Colin Plumb.
 *
 *   It contains extra function for home plug devices pwd handling.
 *   Copyrighted 2003 by devolo AG
 *
     Redistribution in source form, with or without modification,
     are NOT permitted.
 *   This program uses explicitly confidential information
 *   about HomePlug standard.
 *
 *
*/
/*
 * This is the header file for the MD5 message-digest algorithm.
 * The algorithm is due to Ron Rivest.  This code was
 * written by Colin Plumb in 1993, no copyright is claimed.
 * This code is in the public domain; do with it what you wish.
 *
 * Equivalent code is available from RSA Data Security, Inc.
 * This code has been tested against that, and is equivalent,
 * except that you don't need to include two pages of legalese
 * with every copy.
 *
 * To compute the message digest of a chunk of bytes, declare an
 * MD5Context structure, pass it to MD5Init, call MD5Update as
 * needed on buffers full of bytes, and then call MD5Final, which
 * will fill a supplied 16-byte array with the digest.
 *
 * Changed so as no longer to depend on Colin Plumb's `usual.h'
 * header definitions; now uses stuff from dpkg's config.h
 *  - Ian Jackson <ijackson@nyx.cs.du.edu>.
 * Still in the public domain.
 */

#ifndef MD5_H
#define MD5_H


#ifdef __cplusplus
extern "C" {
#endif
  
typedef unsigned int uint32;
#define UWORD32 uint32
#define md5byte unsigned char

#define STRSIZE 8
#define MAXREPEAT 1000

#ifndef FALSE
    #define FALSE       0
#endif
#ifndef TRUE
    #define TRUE        1
#endif


typedef struct MD5Context {
  uint32 buf[4];
  uint32 bytes[2];
  uint32 in[16];
} MD5Context_t ;


void MD5Init(struct MD5Context *context);
void MD5Update(struct MD5Context *context, md5byte const *buf, unsigned len);
void MD5Final(unsigned char digest[16], struct MD5Context *context);
void MD5Transform(uint32 buf[4], uint32 const in[16]);

unsigned char* MD5HomePlugKey(char *cPassword );
unsigned char* MD5DigestString(char *pString, int iLen );


#ifdef __cplusplus
}
#endif

#endif /* !MD5_H */
