#ifndef SHA256_H
#define SHA256_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


typedef struct sha256context
{
	unsigned long total[2];
	unsigned long state[8];
	unsigned char buffer[64];

} sha256context_t;



typedef struct saltedSecret
{
	unsigned char length;
	unsigned char value[72];

} saltedSecret_t;



void InitializeSha256Context( sha256context_t *context);
void InitializeSaltedSecret( saltedSecret_t *secret, const unsigned char *iSecret, const unsigned char *iSalt);
void InitializeSaltedNMK( saltedSecret_t *secret, const unsigned char *iSecret);
void InitializeSaltedDAK( saltedSecret_t *secret, const unsigned char *iSecret);
void InitializeSaltedNID( saltedSecret_t *secret, const unsigned char *iSecret);

void ProcessContext( sha256context_t *context, unsigned char data[64]);
void UpdateContext( sha256context_t *context, unsigned char *input, unsigned long length);
void FinishContext( sha256context_t *context);
const unsigned char* HashNMK(const unsigned char* iSecret);
const unsigned char* HashDAK(const unsigned char* iSecret);
const unsigned char* HashNID(const unsigned char* iSecret);

void NetworkKeyFromPassword(const unsigned char *password, unsigned char *key);
void DeviceAccessKeyFromSecurityID(const unsigned char *securityID, unsigned char *dak);
void dosomething();

#endif

